Subject: Comments about the 3.92 release...

From: kremžská HOŘČICE <[email-masked]>
Date: Tue, 19 Mar 1996 20:57:39 +0100

[continued from my response to the general announcement:]

    Features of this new release of Pine which may be of special interest
to users in CZ/SK, as well as to users anywhere, include...

* Support for 8BITMIME ESMTP dialog, when configured to do this and when
talking to a SMTP server which supports this, such as BSD Sendmail 8.7.*.
This means that instead of always sending text with non-ASCII characters
as QUOTED-PRINTABLE (or quoted-unreadable :-), you have the possibility to
send your message with 8-bit characters when the recipient announces
support for 8BITMIME.

* Support for RFC1522 headers, which will allow your name to look as ugly
as my name does here, and permit you to use your native character set in
e-mail and news headers.

* Support for 8-bit NNTP transfer for news articles.  Earlier this month,
the central Czech news server appears to have been retired and replaced by
one running more up-to-date code, and for the first time, it's possible to
read news originating outside of CZ and SK with 8-bit data intact, although
with still a several day delay.  This will mean that you can also send
newsposts this way -- while a little bit controversial, it is a widely-
accepted practice.

* A way to enter 8-bit characters, even if the keyboard drivers do not
allow one to do so directly, by ESC-ESC-decimalcode for the desired char.

* One can now configure the DELETE key on many keyboards to perform a
forward-character-deletion, as one may know it from the PC keyboard.

* Support for external programs to be called when displaying or sending a
message.  One possible use of this is to provide a translation from and to
the Windows code page 1250 which is widely used in CZ/SK, to make those
characters which differ from the recommended ISO-8859-2 Internet on-the-
wire character set match with Micro$oft's idea of that character set, in
a manner similar to the ISO_TO_CP and CP_TO_ISO tables which PC-Pine can
use to translate ISO-8859-2 to and from CP852 or Kamenicky or whatever.
I have not verified this for the final release, but the source code for the
preliminary releases looked like it did not make use of these tables when
one was using Pine on a Windows machine.

* Support for a mime-types file to permit labelling of MIME attachments in
mail sent, beyond those types supported in previous releases of Pine.

* Support for the mouse under the X-Windows system when configured for
this, as well as support for new mail notification in an X icon.  Mouse
support can also be enabled for the standalone Pico editor as ``pico -m''.
The appearance of Pine will still be the same character-based program, but
one will now be able to click on the names of commands to execute them,
or select messages this way, plus select and paste text.  Note that you
need to use the shift key along with the mouse buttons for selecting and
pasting text.

* Too many more to list here.

    These are some of the more significant features of this new release,
and present Pine users will also see improvements in the way it operates.
You are advised to look to the release notes for a broader overview of all
that is new, improved, or fixed from the previous releases.

    Here are some notes of general interest I have from working with the
pre-releases that have led up to this final product which is tantalizingly
close to you:

    There are a number of new options, such as the mouse support.  You
should probably run this new Pine, read the mildly overwhelming Release
notes which are available from the Main menu, as well as being found in the
docs/ directory of the FTP server and mirrors, and then go directly to the
configuration screen.  There you can select the options you wish to be
available to you -- at any point, you should use ^G to Get help about a
particular option.  When you've selected all the options which are appealing
to you, you should exit and save the configuration options, then I suggest
you quit and restart Pine.  If you don't, there seem to be some options
which do not completely take effect.  Starting fresh seems to correct this.

    If you want to take advantage of the X support, you will need to run
Pine in an xterm, and one way to do this is to create an alias for pine,
which starts an xterm running Pine, with the font to match your charset.

    As noted, the external program hooks could be used to provide a quick
translation from the over-the-wire character set to that which is in use
locally for the display, and to convert back to the over-the-wire character
set.  This has obvious applications for the Windoze code page used in
central and eastern Europe, which has slight differences from the desired
ISO-8859-2 charset.  The disadvantage is that this conversion is only in
effect for the message body and does not include the headers.  At least
Pine will get the charset tagging in the headers correct, unlike certain
commercial products, if you have your charset value specified properly.
I would have preferred a more general expansion of the DOS Pine ISO_TO_CP
principle to also handle Windows (if not also Unix where some Windows-based
telnet application is in use), but since Nyetscape blew off the CE Windows
users also, I'm happy there are these hooks, even though many users will
likely want to make use of the hooks for messages with particular strings,
like  -----BEGIN ...

    One might be able to use these external program hooks to echo the xterm
escape sequence which can be used to dynamically change the font used in
the display to match messages received in different character sets.  I have
not experimented with this yet.

    It appears from my work with the final pre-release that at least for
some platforms, there may be difficulties in displaying certain characters
in some character sets, which have printable characters in positions where
the ISO 8859 series of character sets do not.  Users who stick to, say,
ISO-8859-2, will not have problems.  However, users who want to support
the Windows CE code page may have difficulties, as may users who would
work with MIME character sets such as KOI8-R.  If this turns out to be a
problem, I have confidence that the Pine authors will be able to make a
fix available for this in reasonably short notice.  Not that I want to
speak for them, but people who have worked with them in getting this new
release out to you know they are very responsive to this sort of problem.

    To take proper advantage of the ESMTP 8BITMIME support, you must set up
Pine as an SMTP client -- that is, to set the value of the SMTP server to be
some machine, probably your mailhub or mailhost.  If this machine is running
a mailer such as Sendmail 8.7.5 which announces 8BITMIME support, then your
message can be transferred as an 8-bit message.  If you are running an old
version of Sendmail, such as 8.6.13 or some IDA variant or even 4.1 (ack),
you will probably want to obtain and install the latest sendmail, which
should not be terribly difficult, or any of several other mailers which also
have 8BITMIME support.  Of course, this is a job for the administrator of
your system if you are only the end user.

    The .mime.types file which Pine expects to see must be in the format
content-type<whitespace>extension[<whitespace>extensions...]   like
  application/x-foo        foo  bar  baz
which matches the Mosaic mime-types file.  However, it seems that Netscape
makes use of a .mime.types file, should you happen to copy it to your own
directory for use, with a format
  type=(content-type)<whitespace>[encoding<whitespace>]exts=(extensions-
  comma-separated)[<whitespace>icon=some-bitmap]
    Pine cannot yet parse this, though it should be a simple matter to
write code to handle this or any other extant mime-types file and contribute
it to <[email-masked]> who would be happy to incorporate it into
the next release.  As an alternative, if you have such a .mime-types file,
you can use your favorite editor to gut the ``type='' and ``exts='' and
convert any commas to whitespace.  Pine should be happy with the file that
results, even if Netscape may barf.  The next Pine release should rationalize
this somewhat -- there wasn't time to cram it into this release.

    The ESC-ESC-decimal means of entering an 8-bit character, when there
is no easy way to enter it directly from the keyboard, works well when you
know what the decimal number representation of the character you desire
happens to be.  This will probably require a table of the commonly used
characters from your language and their decimal equivalents in the
character set you happen to use.  For example, I know that the u-diaeresis
(or German u with umlaut) has decimal position 252 in both the common
Latin-1 (ISO-8859-1) encoding, as well as in the ISO-8859-2 which is more
likely to be used in this country.  So if I'm sending messages to my banker
friends in Switzerland and want to impress them by putting a couple dots
atop their city's name, I would use the sequence of keystrokes...
Z-ESC-ESC-2-5-2-r-i-c-h    ...
if I don't have a keyboard with the character I want immediately available.
Of course, you may need to find a reference which lists all the characters
which are available in your selected character set, so that you know the
decimal codes for the position of each.  Never fear, there are such things
available on the Net for you.
    One of the worst, based on something I found several years ago and to
which I added additional character sets, can be retrieved as
ftp://ftp.radio.cz/charsets/iso8859
This is a rather lengthy text file, and the original was written in German,
and I added to it and never got around to cleaning it up or even adding
more to it to reflect additional ISO8859 character sets.  However, in this,
you will find a table of all the characters in a particular subset of 8859,
plus the hexadecimal and decimal codes for the position of each described
character in the table.  From this, you should be able to create a list of
any character which you need to type and its corresponding decimal number.
Do not trust this table for too much else -- while most of it is reliable,
it is work which used to be in progress but was put on the back burner and
the heat turned way down.

    My congratulations and thanks to all on the Pine Team for providing
still another release of Pine, which is easy enough for almost anyone to use,
yet powerful enough for advanced users, and includes built-in support for
MIME and 8-bit handling, making it useful for not only the intended Univ of
Washington community, but for users throughout the world.

    Sigh...  Fun's over.  Now back to Real Work...

Barry Bouwsma, Radio Prahahaha Beer and Chocolate Tester
<[email-masked]>  for public PGP key
<[email-masked]>     http://www.radio.cz/~beery